      PROGRAM POLCAL
C     ----------------------------------------------------------------
C     Alg4'2.for   FORTRAN program for implementing Algorithm 4.2
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 4.2 (Polynomial Calculus).
C     Section   4.2, Introduction to Interpolation, Page 212
C     ----------------------------------------------------------------
      PARAMETER(MaxN=15)
      INTEGER Meth,N
      REAL C,DP,IP,P
      CHARACTER ANS*1
      DIMENSION C(0:MaxN)
      EXTERNAL DP,IP,P
10    CALL GETPOLY(C,N)
20    CALL CHOICE(C,N,Meth)
      CALL EVALUATE(C,N,Meth)
      WRITE(9,*)' '
      WRITE(9,*)'WANT ANOTHER CHOICE ? '
      READ(9,'(A)') ANS
      IF(ANS .EQ. 'Y' .OR. ANS .EQ. 'y') GOTO 20
      WRITE(9,*)' '
      WRITE(9,*)'WANT ANOTHER POLYNOMIAL ? '
      READ(9,'(A)') ANS
      IF(ANS .EQ. 'Y' .OR. ANS .EQ. 'y') GOTO 10
      RETURN
      END

      REAL FUNCTION P(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Poly,X
      DIMENSION C(0:MaxN)
        Poly=C(N)
        DO K=(N-1),0,-1
          Poly=C(K)+Poly*X
        ENDDO
        P=Poly
        RETURN
      END

      REAL FUNCTION DP(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Deriv,X
      DIMENSION C(0:MaxN)
        Deriv=N*C(N)
        DO K=(N-1),1,-1
          Deriv=K*C(K)+Deriv*X
        ENDDO
        DP=Deriv
        RETURN
      END

      REAL FUNCTION IP(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Integ,X
      DIMENSION C(0:MaxN)
        Integ=C(N)/(N+1)
        DO K=N,1,-1
          Integ=C(K-1)/K+Integ*X
        ENDDO
        Integ=Integ*X
        IP=Integ
        RETURN
      END

      REAL FUNCTION XP(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Poly,X
      DIMENSION C(0:MaxN)
      Poly=C(N)
      DO 10 K=(N-1),0,-1
        Poly=C(K)+Poly*X
10    CONTINUE
      P=Poly
      RETURN
      END

      REAL FUNCTION XDP(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Deriv,X
      DIMENSION C(0:MaxN)
      Deriv=N*C(N)
      DO 10 K=(N-1),1,-1
        Deriv=K*C(K)+Deriv*X
10    CONTINUE
      DP=Deriv
      RETURN
      END

      REAL FUNCTION XIP(C,N,X)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C,Integ,X
      DIMENSION C(0:MaxN)
      Integ=C(N)/(N+1)
      DO 10 K=N,1,-1
        Integ=C(K-1)/K+Integ*X
10    CONTINUE
      Integ=Integ*X
      IP=Integ
      RETURN
      END

      SUBROUTINE  PRINTPOL(C,N)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C
      DIMENSION C(0:MaxN)
      IF (N.EQ.1) THEN
        WRITE(9,*)' '
        WRITE(9,*)'P(X)  =  C X  +  C'
        WRITE(9,*)'          1       0'
        WRITE(9,*)' '
      ELSEIF (N.EQ.2) THEN
        WRITE(9,*)'            2'
        WRITE(9,*)'P(X)  =  C X   +  C X  +  C'
        WRITE(9,*)'          2        1       0'
        WRITE(9,*)' '
      ELSEIF (N.EQ.3) THEN
        WRITE(9,*)'            3        2'
        WRITE(9,*)'P(X)  =  C X   +  C X   +  C X  +  C '
        WRITE(9,*)'          3        2        1       0'
        WRITE(9,*)' '
      ELSE
        WRITE(9,*)'           ',N,'            2'
        WRITE(9,*)'P(X)  =  C X   +...+  C X  +   C X  +  C '
        WRITE(9,*)'         ',N,'            2        1       0'
        WRITE(9,*)' '
      ENDIF
      DO 10 K=N,0,-2
        IF (K.GE.1) THEN
          WRITE(9,*)'C(',K,')  =',C(K),'     C(',(K-1),')  =',C(K-1)
        ELSE
          WRITE(9,*)'C(',K,')  =',C(K)
        ENDIF
10    CONTINUE
      RETURN
      END
      
      SUBROUTINE GETPOLY(C,N)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL C
      DIMENSION C(0:MaxN)
      DO 10 I=1,18
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'POLYNOMIAL CALCULUS FOR EVALUATING, DIFFERENTIATING'
      WRITE(9,*)' '
      WRITE(9,*)'AND INTEGRATING THE POLYNOMIAL P(X) OF DEGREE N. '
      WRITE(9,*)' '
      WRITE(9,*)'          N       N-1         2          '
      WRITE(9,*)'P(X) = C X + C   X   +...+ C X + C X + C '
      WRITE(9,*)'        N     N-1           2     1     0'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE DEGREE  N = '
      READ(9,*) N
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE ',N+1,' COEFFICIENTS'
      WRITE(9,*)' '
      WRITE(9,*)'         C , ... , C , C , C '
      WRITE(9,*)'         ',N,'         2   1   0'
      WRITE(9,*)' '
      DO 20 K=N,0,-1
        WRITE(9,*)'C(',K,') = '
      READ(9,*) C(K)
20    CONTINUE
      RETURN
      END

      SUBROUTINE CHOICE(C,N,Meth)
      PARAMETER(MaxN=15)
      INTEGER I,Meth,N
      REAL C
      DIMENSION C(0:MaxN)
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'THE POLYNOMIAL OF DEGREE ',N,' IS:'
      WRITE(9,*)' '
      CALL PRINTPOL(C,N)
      WRITE(9,*)' '
      WRITE(9,*)'CHOOSE ONE OF THE FOLLOWING:'
      WRITE(9,*)' '
      WRITE(9,*)'1 - EVALUATE   P(X)'
      WRITE(9,*)' '
      WRITE(9,*)'2 - EVALUATE  P`(X)'
      WRITE(9,*)' '
      WRITE(9,*)'3 - INTEGRATE  P(X)  OVER  [A,B]'
      WRITE(9,*)' '
      WRITE(9,*)'SELECT <1-3> '
      READ(9,*) Meth
      WRITE(9,*)' '
      RETURN
      END

      SUBROUTINE EVALUATE(C,N,Meth)
      PARAMETER(MaxN=15)
      INTEGER I,Meth,N
      REAL A,B,C,Deriv,DP,IntAB,IP,P,Poly,X
      DIMENSION C(0:MaxN)
      EXTERNAL DP,IP,P
      DO 10 I=1,15
        WRITE(9,*)' '
10    CONTINUE
      IF (Meth.EQ.1) THEN
        WRITE(9,*)'YOU CHOSE TO EVALUATE THE POLYNOMIAL  P(X):'
      ELSEIF (Meth.EQ.2) THEN
        WRITE(9,*)'YOU CHOSE TO DIFFERENTIATE THE POLYNOMIAL  P(X):'
      ELSEIF (Meth.EQ.3) THEN
        WRITE(9,*)'YOU CHOSE TO INTEGRATE THE POLYNOMIAL  P(X):'
      ENDIF
      WRITE(9,*)' '
      CALL PRINTPOL(C,N)
      WRITE(9,*)' '
      IF (Meth.EQ.1) THEN
        WRITE(9,*)'EVALUATE   P(X)'
        WRITE(9,*)' '
        WRITE(9,*)'   ENTER     X = '
        READ(9,*) X
        WRITE(9,*)' '
        Poly=P(C,N,X)
        WRITE(9,*)'P(',X,'  ) = ',Poly
      ELSEIF (Meth.EQ.2) THEN
        WRITE(9,*)'EVALUATE  P`(X)'
        WRITE(9,*)' '
        WRITE(9,*)'   ENTER     X = '
        READ(9,*) X
        WRITE(9,*)' '
        Deriv=DP(C,N,X)
        WRITE(9,*)'P`(',X,'  ) = ',Deriv
      ELSEIF (Meth.EQ.3) THEN
        WRITE(9,*)'INTEGRATE  P(X)  OVER   [A,B]'
        WRITE(9,*)' '
        WRITE(9,*)'ENTER THE LEFT ENDPOINT  A = '
        READ(9,*) A
        WRITE(9,*)'ENTER THE RIGHT ENDPOINT B = '
        READ(9,*) B
        IntAB=IP(C,N,B)-IP(C,N,A)
        WRITE(9,*)' '
        WRITE(9,*)'B'
        WRITE(9,*)'/'
        WRITE(9,*)'| P(X) DX  = ',IntAB
        WRITE(9,*)'/'
        WRITE(9,*)'A'
      ENDIF
      WRITE(9,*)' '
      RETURN
      END
