      PROGRAM NESTEDM
C     ----------------------------------------------------------------
C     Alg4'4.for   FORTRAN program for implementing Algorithm 4.4
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 4.4 (Nested Multiplication with Multiple Centers).
C     Section   4.4, Newton Polynomials, Page 233
C     ----------------------------------------------------------------
      PARAMETER(MaxN=15)
      INTEGER N
      REAL A,P,T,X
      CHARACTER ANS*1
      DIMENSION A(0:MaxN),X(0:MaxN)
      EXTERNAL P
10    CALL GETDATAS(A,X,N)
20    CALL EVALUATE(A,X,N,T)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO EVALUATE P(T) AGAIN ? '
      READ(9,'(A)') ANS
      IF(ANS .EQ. 'Y' .OR. ANS .EQ. 'y') GOTO 20
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO EVALUATE ANOTHER POLYNOMIAL ? '
      READ(9,'(A)') ANS
      IF(ANS .EQ. 'Y' .OR. ANS .EQ. 'y') GOTO 10
      RETURN
      END

      REAL FUNCTION P(A,X,N,T)
      PARAMETER(MaxN=15)
      INTEGER K,N
      REAL A,Sum,T,X
      DIMENSION A(0:MaxN),X(0:MaxN)
        Sum=A(N)
        DO K=(N-1),0,-1
          Sum=Sum*(T-X(K))+A(K)
        ENDDO
        P= Sum
        RETURN
      END

      REAL FUNCTION XP(A,X,N,T)
      PARAMETER(MaxN=15)
      INTEGER K,N
      REAL A,Sum,T,X
      DIMENSION A(0:MaxN),X(0:MaxN)
      Sum=A(N)
      DO 10 K=(N-1),0,-1
        Sum=Sum*(T-X(K))+A(K)
10    CONTINUE
      P= Sum
      RETURN
      END

      SUBROUTINE PRINTPOL(A,X,N)
      PARAMETER(MaxN=15)
      INTEGER K,N
      REAL A,X
      DIMENSION A(0:MaxN),X(0:MaxN)
        WRITE(9,*)' '
      IF (N.EQ.1) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ]'
        WRITE(9,*)'        0    1    0 '
      ELSEIF (N.EQ.2) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1 '
      ELSEIF (N.EQ.3) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X
     +][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +     2 '
      ELSE
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X
     +][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +     2'
        WRITE(9,*)'       +...+ A [T-X ][T-X ] ... [T-X   ]'
        WRITE(9,*)'    ',N,'    0     1',(N-1)
        WRITE(9,*)' '
        WRITE(9,*)'N =',N
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'THE COEFFICIENTS:                   THE CENTERS:'
      WRITE(9,*)' '
      DO 10 K=0,(N-1)
        WRITE(9,*)'A(',K,')  =',A(K),'                    X(',K,')  =',
     +X(K)
10    CONTINUE
      WRITE(9,*)'A(',N,')  =',A(N)
      RETURN
      END

      SUBROUTINE GETDATAS(A,X,N)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL A,X
      DIMENSION A(0:MaxN),X(0:MaxN)
      DO 10 I=1,18
      WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'NESTED MULTIPLICATION IS USED TO EVALUATE THE NEWTON PO
     +LYNOMIAL:'
      WRITE(9,*)' '
      WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X ][
     +T-X ]'
      WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +   2'
      WRITE(9,*)'       +...+ A [T-X ][T-X ]...[T-X   ]'
      WRITE(9,*)'              N    0     1        N-1'
      WRITE(9,*)' '
      WRITE(9,*)'THE CENTERS ARE   X  , X  ,..., X    AND THE'
      WRITE(9,*)'                   0    1        N-1 '
      WRITE(9,*)' '
      WRITE(9,*)'COEFFICIENTS ARE  A  , A  ,..., A    , A  '
      WRITE(9,*)'                   0    1        N-1    N '
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE DEGREE  N = '
      READ(9,*) N
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE ',N,' CENTERS'
      WRITE(9,*)' '
      DO 20 K=0,(N-1)
        WRITE(9,*)'X(',K,') = '
        READ(9,*) X(K)
20    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE ',N+1,' COEFFICIENTS'
      WRITE(9,*)' '
      DO 30 K=0,N
        WRITE(9,*)'A(',K,') = '
        READ(9,*) A(K)
30    CONTINUE
      WRITE(9,*)' '
      RETURN
      END

      SUBROUTINE EVALUATE(A,X,N,T)
      PARAMETER(MaxN=15)
      INTEGER I,N
      REAL A,P,Poly,T,X
      DIMENSION A(0:MaxN),X(0:MaxN)
      EXTERNAL P
      DO 10 I=1,18
        WRITE(9,*)' '
10    CONTINUE
      CALL PRINTPOL(A,X,N)
      WRITE(9,*)' '
      WRITE(9,*)'NOW EVALUATE  P(T)'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER A VALUE   T = '
      READ(9,*) T
      WRITE(9,*)' '
      WRITE(9,*)'THE VALUE OF THE NEWTON POLYNOMIAL IS '
      WRITE(9,*)' '
      Poly=P(A,X,N,T)
      WRITE(9,*)'P(',T,'  )  = ',Poly
      RETURN
      END
