      PROGRAM LEASTSQ
C     ----------------------------------------------------------------
C     Alg5'1.for   FORTRAN program for implementing Algorithm 5.1
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 5.1 (Least Squares Line).
C     Section   5.1, Least-Squares Line, Page 264
C     ----------------------------------------------------------------
      PARAMETER(MaxN=200)
      INTEGER N
      REAL A,B,X,Y
      CHARACTER ANS*1
      DIMENSION X(1:MaxN),Y(1:MaxN)
10    CALL GETDATA(X,Y,N)
      CALL REGRESS(X,Y,N,A,B)
      CALL RESULTS(X,Y,N,A,B)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO FIND ANOTHER LEAST SQUARES LINE ? '
      READ(9,'(A)') ANS
      IF(ANS .EQ. 'Y' .OR. ANS .EQ. 'y') GOTO 10
      STOP
      END

      SUBROUTINE REGRESS(X,Y,N,A,B)
      PARAMETER(MaxN=200)
      INTEGER K,N
      REAL A,B,SumX,SumXY,X,Xmean,Y,Ymean
      DIMENSION X(1:MaxN),Y(1:MaxN)
      Xmean=0
      DO K=1,N
        Xmean=Xmean+X(K)
      ENDDO
      Xmean=Xmean/N
      Ymean=0
      DO K=1,N
        Ymean=Ymean+Y(K)
      ENDDO
      Ymean=Ymean/N
      SumX=0
      DO K=1,N
        SumX=SumX+(X(K)-Xmean)*(X(K)-Xmean)
      ENDDO
      SumXY=0
      DO K=1,N
        SumXY=SumXY+(X(K)-Xmean)*(Y(K)-Ymean)
      ENDDO
      A=SumXY/SumX
      B=Ymean-A*Xmean
      RETURN
      END

      SUBROUTINE XEGRESS(X,Y,N,A,B)
      PARAMETER(MaxN=200)
      INTEGER K,N
      REAL A,B,SumX,SumXY,X,Xmean,Y,Ymean
      DIMENSION X(1:MaxN),Y(1:MaxN)
      Xmean=0
      DO 10 K=1,N
        Xmean=Xmean+X(K)
10    CONTINUE
      Xmean=Xmean/N
      Ymean=0
      DO 20 K=1,N
        Ymean=Ymean+Y(K)
20    CONTINUE
      Ymean=Ymean/N
      SumX=0
      DO 30 K=1,N
        SumX=SumX+(X(K)-Xmean)*(X(K)-Xmean)
30    CONTINUE
      SumXY=0
      DO 40 K=1,N
        SumXY=SumXY+(X(K)-Xmean)*(Y(K)-Ymean)
40    CONTINUE
      A=SumXY/SumX
      B=Ymean-A*Xmean
      RETURN
      END

      SUBROUTINE GETDATA(X,Y,N)
      PARAMETER(MaxN=200)
      INTEGER I,K,N
      REAL X,Y
      DIMENSION X(1:MaxN),Y(1:MaxN)
      DO 10 I=1,18
      WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'THE LEAST SQUARES LINE Y = AX + B IS CONSTRUCTED.'
      WRITE(9,*)' '
      WRITE(9,*)'IT FITS THE POINTS (X ,Y ), (X ,Y ),..., (X ,Y )'
      WRITE(9,*)'                     1  1     2  2         N  N '
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE NUMBER OF POINTS  N = '
      READ(9,*) N
      IF (N.LT.2) THEN
        N=2
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE ',N,' POINTS'
      WRITE(9,*)' '
      DO 20 K=1,N
        WRITE(9,*)'X(',K,') = '
        READ(9,*) X(K)
        WRITE(9,*)'Y(',K,') = '
        READ(9,*) Y(K)
        WRITE(9,*)' '
20    CONTINUE
      RETURN
      END

      SUBROUTINE RESULTS(X,Y,N,A,B)
      PARAMETER(MaxN=200)
      INTEGER I,K,N
      REAL A,B,Err,X,Y,Z
      DIMENSION X(1:MaxN),Y(1:MaxN)
      DO 10 I=1,18
      WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)' '
      WRITE(9,*)'THE LEAST SQUARES LINE IS  Y = A*X + B, WHERE:'
      WRITE(9,*)' '
      WRITE(9,*)'A = ',A,'     B = ',B
      WRITE(9,*)' '
      WRITE(9,*)'    K      X           Y           A*X + B       Error'
      WRITE(9,*)'            K           K             K'
      WRITE(9,*)'  ----------------------------------------------------
     +----'
      DO 20 K=1,N
        Z=A*X(K)+B
        Err=Y(K)-Z
        WRITE(9,999) K,X(K),Y(K),Z,Err
20    CONTINUE
999   FORMAT(I5,2F12.5,2F14.7)
      RETURN
      END
