      PROGRAM NEWPOLYD
C     ----------------------------------------------------------------
C     Alg6'3.for   FORTRAN program for implementing Algorithm 6.3
C     
C     NUMERICAL METHODS: FORTRAN Programs, (c) John H. Mathews 1995
C     To accompany the text:
C     NUMERICAL METHODS for Math., Science & Engineering, 2nd Ed, 1992
C     Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
C     Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
C     Prentice Hall, International Editions:   ISBN 0-13-625047-5
C     This free software is compliments of the author.
C     E-mail address:       in%"mathews@fullerton.edu"
C     
C     Algorithm 6.3 (Differentiation Based on N+1 Nodes). 
C     Section   6.2, Numerical Differentiation Formulas, Page 342
C     ----------------------------------------------------------------
      PARAMETER(MaxN=15)
      INTEGER N
      REAL A,Df,X,Y
      CHARACTER ANS*1
      DIMENSION A(0:MaxN),X(0:MaxN),Y(0:MaxN)
10    CALL GETDATA(X,Y,N)
      CALL DIFPOLY(A,X,Y,N,Df)
      CALL RESULTS(A,X,Y,N,Df)
      WRITE(9,*)' '
      WRITE(9,*)'WANT TO USE A DIFFERENT SET OF DATA POINTS ? '
      READ(9,'(A)') ANS
      IF (ANS.EQ.'Y' .OR. ANS.EQ.'y') GOTO 10
      END

      SUBROUTINE DIFPOLY(A,X,Y,N,Df)
      PARAMETER(MaxN=15)
      INTEGER J,K,N
      REAL A,Df,Prod,T,X,Y
      DIMENSION A(0:MaxN),X(0:MaxN),Y(0:MaxN)
      DO K=0,N
        A(K)=Y(K)
      ENDDO
      DO J=1,N
        DO K=N,J,-1
          A(K)=(A(K)-A(K-1))/(X(K)-X(K-J))
        ENDDO
      ENDDO
      T=X(0)
      Df=A(1)
      Prod=1
      DO K=2,N
        Prod=Prod*(T-X(K-1))
        Df=Df+Prod*A(K)
      ENDDO
      RETURN
      END

      SUBROUTINE XIFPOLY(A,X,Y,N,Df)
      PARAMETER(MaxN=15)
      INTEGER J,K,N
      REAL A,Df,Prod,T,X,Y
      DIMENSION A(0:MaxN),X(0:MaxN),Y(0:MaxN)
      DO 10 K=0,N
        A(K)=Y(K)
10    CONTINUE
      DO 30 J=1,N
      DO 20 K=N,J,-1
        A(K)=(A(K)-A(K-1))/(X(K)-X(K-J))
20    CONTINUE
30    CONTINUE
      T=X(0)
      Df=A(1)
      Prod=1
      DO 40 K=2,N
        Prod=Prod*(T-X(K-1))
        Df=Df+Prod*A(K)
40    CONTINUE
      RETURN
      END

      SUBROUTINE PRINTPOL(A,X,Y,N)
      PARAMETER(MaxN=15)
      INTEGER K,N
      REAL A,X,Y
      DIMENSION A(0:MaxN),X(0:MaxN),Y(0:MaxN)
        WRITE(9,*)' '
      IF (N.EQ.1) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ]'
        WRITE(9,*)'        0    1    0 '
      ELSEIF (N.EQ.2) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1 '
      ELSEIF (N.EQ.3) THEN
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X
     +][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +     2 '
      ELSE
        WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X
     +][T-X ]'
        WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +     2'
        WRITE(9,*)'       +...+ A [T-X ][T-X ] ... [T-X ]'
        WRITE(9,*)'    ',N,'    0     1',(N-1)
      ENDIF
      WRITE(9,*)' '
      WRITE(9,*)'         THE COEFFICIENTS:  THE ABSCISSAS:       THE OR
     +DINATES:'
      WRITE(9,*)'K            A(K)                X(K)                Y(
     +K)'
      WRITE(9,*)' '
      DO 10 K=0,N
        WRITE(9,999) K,A(K),X(K),Y(K)
10    CONTINUE
999   FORMAT(1X,I2,3F20.7)
      RETURN
      END

      SUBROUTINE GETDATA(X,Y,N)
      PARAMETER(MaxN=15)
      INTEGER I,K,N
      REAL X,Y
      DIMENSION X(0:MaxN),Y(0:MaxN)
      DO 10 I=1,18
      WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'     THE DERIVATIVE OF THE NEWTON POLYNOMIAL'
      WRITE(9,*)' '
      WRITE(9,*)'P(T) = A  + A [T-X ] + A [T-X ][T-X ] + A [T-X ][T-X ][
     +T-X ]'
      WRITE(9,*)'        0    1    0     2    0     1     3    0     1
     +   2'
      WRITE(9,*)'       +...+ A [T-X ][T-X ]...[T-X   ]'
      WRITE(9,*)'              N    0     1        N-1'
      WRITE(9,*)' '
      WRITE(9,*)'IS USED TO APPROXIMATE THE DERIVATIVE AT THE POINT (X ,
     +Y ).'
      WRITE(9,*)'                                                     0
     + 0'
      WRITE(9,*)' '
      WRITE(9,*)'P(T) IS BASED ON THE N+1 NODES (X ,Y ),(X ,Y ),...,(X ,
     +Y ).'
      WRITE(9,*)'                                 0  0    1  1        N
     + N  '
      WRITE(9,*)' '
      WRITE(9,*)'THE VALUES {X } DO NOT NEED TO BE INCREASING.'
      WRITE(9,*)'             K'
      WRITE(9,*)' '
      WRITE(9,*)'ENTER THE NUMBER  N = '
      READ(9,*) N
      WRITE(9,*)' '
      WRITE(9,*)'NOW ENTER THE ',N+1,' POINTS'
      WRITE(9,*)' '
      DO 20 K=0,N
        WRITE(9,*)'X(',K,') = '
        READ(9,*) X(K)
        WRITE(9,*)'Y(',K,') = '
        READ(9,*) Y(K)
        WRITE(9,*)' '
20    CONTINUE
      RETURN
      END

      SUBROUTINE RESULTS(A,X,Y,N,Df)
      PARAMETER(MaxN=15)
      INTEGER I,N
      REAL A,Df,X,Y
      DIMENSION A(0:MaxN),X(0:MaxN),Y(0:MaxN)
      DO 10 I=1,18
        WRITE(9,*)' '
10    CONTINUE
      WRITE(9,*)'    THE NEWTON POLYNOMIAL OF DEGREE ',N,' IS:'
      WRITE(9,*)' '
      CALL PRINTPOL(A,X,Y,N)
      WRITE(9,*)' '
      WRITE(9,*)'THE APPROXIMATION FOR THE DERIVATIVE AT X  =',X(0)
      WRITE(9,*)'                                         0'
      WRITE(9,*)'USING THE NEWTON POLYNOMIAL IS:'
      WRITE(9,*)' '
      WRITE(9,*)'P`(',X(0),'  ) = ',Df
      WRITE(9,*)' '
      RETURN
      END
